# SymlinkTask

Extends \Task

Generates symlinks based on a target / link combination.

Can also symlink contents of a directory, individually

Single target symlink example: ``

Symlink entire contents of directory

This will go through the contents of "/my/shared/library/*" and create a symlink for each entry into ${project.basedir}/library/ ``

author | Andrei Serdeliuc andrei@serdeliuc.ro
extends | Task
version | $ID$
package | phing.tasks.ext

### Methods

## creator for _filesets

    createFileset() : \FileSet

### Response

`\FileSet`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## getter for _filesets

    getFilesets() : array

### Response

`array`

## getter for _link

    getLink() : string

throws |

### Response

`string`

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Generates an array of directories / files to be linked If _filesets is empty, returns getTarget()

    getMap() : array|string

throws |

### Response

`array|string`

## getter for _overwrite

    getOverwrite() : boolean

### Response

`boolean`

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## getter for _target

    getTarget() : string

throws |

### Response

`string`

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## setter for _link

    setLink(string $link) : void

### Arguments

#### $link

`string`

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## setter for _overwrite

    setOverwrite(boolean $overwrite) : void

### Arguments

#### $overwrite

`boolean`

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## setter for _target

    setTarget(string $target) : void

### Arguments

#### $target

`string`

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Create the actual link

    symlink(string $target, string $link) : boolean

### Arguments

#### $target

`string`

#### $link

`string`

### Response

`boolean`

### Properties

## What we're symlinking from

    _target : string

(default value: null)

var |

### Type(s)

`string`

## Symlink location

    _link : string

(default value: null)

var |

### Type(s)

`string`

## Collection of filesets Used when linking contents of a directory

    _filesets : array

(default value: array())

var |

### Type(s)

`array`

## Whether to override the symlink if it exists but points to a different location

    _overwrite : boolean

(default value: false)

var |

### Type(s)

`boolean`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`